export interface OnFetchRequest {
    (rq: [url: RequestInfo | URL, init?: RequestInit | undefined]): void;
}
export interface OnFetchResponse {
    (rs: Response): void;
}
export interface XMLHttpRequestInit {
    method: string;
    headers: Headers;
    body: XMLHttpRequestBodyInit;
    responseType: XMLHttpRequestResponseType;
}
export interface onXHRRequest {
    (rq: [url: RequestInfo | URL, init?: XMLHttpRequestInit]): void;
}
/**
 * Taken from https://developer.mozilla.org/en-US/docs/Web/API/XMLHttpRequest/response
 */
export type XMLHTTPRequestResponseBody = string | Document | ArrayBuffer | Blob | Record<string, unknown> | null;
export interface onXHRResponse {
    (rs: {
        url: string;
        status: number;
        statusText: string;
        headers: Headers;
        body: XMLHTTPRequestResponseBody;
        responseType: XMLHttpRequestResponseType;
    }): void;
}
/**
 * NetworkInterceptor class to intercept network requests and responses
 */
export declare class NetworkInterceptor {
    addFetchInterceptor(onRequest: OnFetchRequest, onResponse: OnFetchResponse): void;
    addXhrInterceptor(onRequest: onXHRRequest, onResponse: onXHRResponse): void;
    cleanup(): void;
}
//# sourceMappingURL=network-interceptor.d.ts.map